/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <pwd.h>
#include <sys/types.h>

#include "callbacks.h"
#include "interface.h"
#include "engine.h"
#include "wpref.h"
#include "wzo.h"


// Zamkniecie aplikacji
void on_MainWindow_destroy(GtkObject * object, gpointer user_data)
{
	gtk_main_quit ();
}


// Zamkniecie aplikacji
void on_wm_quit1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
	}
	
	gtk_main_quit ();
}


// Wybranie pozycji Informacje o w menu pomoc - wyswietlenie okna window_about
void on_mw_about1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	GtkWidget *window_about;
	window_about = create_window_about ();
	gtk_widget_show (window_about);
}


// Klikniecie na wybrany dzien w kalendarzu - wczytywanie wpisu
void on_mw_kalendarz_day_selected(GtkCalendar * calendar, gpointer user_data)
{
	typ_data tmp;
	gtk_calendar_get_date (calendar, &tmp.rok, &tmp.miesiac, &tmp.dzien);
	edytuj_wpis (tmp);
}


// Pokazanie okna MainWindow - poczatkowe operacje (wczytanie baz danych, itp)
void on_MainWindow_show (GtkWidget *widget, gpointer user_data)
{
	// Odczytywanie katalogu domowego
	struct passwd *dane = getpwuid (getuid ());
	
	strcpy (katalog_ustawien, dane->pw_dir);
	strcat (katalog_ustawien, "/.gnutu");
	
	// Wczytywanie baz danych....
	pobierz_biezaca_date ();
	wczytaj_baze         ();
	wczytaj_plan_lekcji  ();
	wczytaj_wolne_dni    ();
	wczytaj_ustawienia   ();

	int numer;
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		wypelnij_pola (baza[numer]);
	} else {
		wypelnij_pola (czysty_wpis ());
		
		if (sprawdz_dzien_wolny (biezaca_data) == TRUE) {
		} else {
			laduj_przedmioty ();
		}
	}
	
	wpisz_biezaca_date ();
	ostatni = sprawdz_ostatni ();
	wyswietl_najblizszy_sprawdzian ();
	wyswietl_licznik ();
	
	printf (_("----------------------\n GNU Terminarz Ucznia\n www.gnutu.org\n----------------------\n\n"));
}


// Zamkniecie okna planu lekcji (window_plan_lekcji)
void on_wpl_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *window_plan_lekcji = lookup_widget (GTK_WIDGET (button), "window_plan_lekcji");
	gtk_widget_destroy (GTK_WIDGET (window_plan_lekcji));
}


// Zapisanie planu lekcji i zamkniecie okna planu lekcji (window_plan_lekcji)
void on_wpl_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	pobierz_plan_lekcji (GTK_WIDGET (button));
	zapisz_plan_lekcji ();
	
	GtkWidget *window_plan_lekcji = lookup_widget (GTK_WIDGET (button), "window_plan_lekcji");
	gtk_widget_destroy (GTK_WIDGET (window_plan_lekcji));
	
	wczytaj_plan_lekcji ();
}


// Wybranie opcji Ustaw plan lekcji (w menu Ustawienia) - wyswietlenie okna
// planu lekcji (window_plan_lekcji)
void on_ustaw_plan_lekcji1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *window_plan_lekcji = create_window_plan_lekcji ();
	
	wczytaj_plan_lekcji  ();
	wypelnij_plan_lekcji (window_plan_lekcji);
	
	gtk_widget_show (GTK_WIDGET (window_plan_lekcji));
}


// Wybranie opcji wstaw przedmioty z menu wpis - wstawienie przedmiotow z planu
// lekcji
void on_wstaw_przedmioty1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	laduj_przedmioty ();
}


// Wybranie opcji szukaj sprawdzianow z menu Wpis - wszyszukanie najblizszych
// 3 sprawdzianow
void on_szukaj_sprawdzianow1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	szukaj_sprawdzianow ();
}


// Zamkniecie glownego okna (MainWindow)
gboolean on_MainWindow_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
		return FALSE;
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
		return FALSE;
	}
}


// Kliknieto na przycisk wstaw przedmioty - wstawia przedmioty z planu lekcji
void on_mw_wstaw_btn_clicked (GtkButton *button, gpointer user_data)
{
	laduj_przedmioty ();
}


// Kliknieto na przcisk szukaj sprawdzianow - wyszukuje najblizsze sprawdziany
void on_mw_szukaj_btn_clicked (GtkButton *button, gpointer user_data)
{
	szukaj_sprawdzianow ();
}


// Kliknieto na przycisk zamkniecia programu - zakonczenie pracy programu
void on_mw_quit_btn_clicked (GtkButton *button, gpointer user_data)
{
	int numer;
	
	if ((numer = szukaj_wpis (biezaca_data)) >= 1) {
		baza[numer] = pobierz_wpis ();
		zapisz_baze ();
	} else {
		ostatni++;
		baza[ostatni] = pobierz_wpis ();
		zapisz_baze ();
	}
	
	gtk_main_quit ();
}


// Wybrano opcje Preferencje z menu Ustawienia - wyswietlenie okna preferencje
void on_preferencje1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wp_widget = create_window_preferencje ();
	wp_wczytaj_ustawienia ();
	wp_wolne_dni_wypelnij ();
	gtk_widget_show (GTK_WIDGET (wp_widget));
}


void on_wp_dodaj_dzien_wolny_btn_clicked (GtkButton *button, gpointer user_data)
{
	wp_wolne_dni_dodaj_dzien_wolny ();
}


void on_wp_usun_dzien_wolny_clicked (GtkButton *button, gpointer user_data)
{
	wp_wolne_dni_usun_dzien_wolny ();
}


void on_wp_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_destroy (GTK_WIDGET (wp_widget));
}


void on_wp_ok_btn_clicked (GtkButton *button, gpointer user_data)
{	
	// Zapisujemy ustawienia
	wp_zapisz_ustawiennia ();
	
	// Zamykamy okno
	gtk_widget_destroy (GTK_WIDGET (wp_widget));
}


void on_wp_wolne_dni_click_column (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	wp_wolne_dni_zaznaczony_zmien (row);
}


void on_wyczysc_pola_przedmiotow1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_przedmioty ();
}


void on_wyczysc_pola_przedmiotow_i_ocen1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_przedmioty ();
	wyczysc_oceny ();
}


void on_wyczysc_notatki__sprawdziany_i_kartkowki1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wyczysc_pozostale ();
}


void on_wyczysc_wszystko1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wypelnij_pola (czysty_wpis ());
}


void on_dzisiejszy_wpis1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *kalendarz = lookup_widget (GTK_WIDGET (menuitem), "mw_kalendarz");
	typ_data   tmp_data  = data ();
	
	gtk_calendar_select_day (GTK_CALENDAR (kalendarz), tmp_data.dzien);
	gtk_calendar_select_month (GTK_CALENDAR (kalendarz), (tmp_data.miesiac - 1), tmp_data.rok);
}


// Kliknieto przycisk ok w oknie wyboru pliku
void on_wwp_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	char *nazwa_pliku = gtk_file_selection_get_filename (GTK_FILE_SELECTION (wwp_widget));
	
	switch (wwp_czynnosc) {
		case 1: // Wybranie pliku kopii zapasowej
				if (strlen (nazwa_pliku) <= 0) {
					komunikat (_("Nie wybrales zadnego pliku !!!"));
				} else {
					// Sprawdza czy plik ma rozszerzenie .gz
					char polecenie[200];
					
					if (nazwa_pliku[strlen (nazwa_pliku)-1] == 'z') {
						sprintf (polecenie, "tar -zxvf ");
					} else {
						sprintf (polecenie, "tar -xvf ");
					}
					
					strcat (polecenie, nazwa_pliku);
					system ("rm .gnutu --recursive");
					system (polecenie);
					wczytaj_baze ();
					cofnij_modyfikacje ();
					
					komunikat (_("Kopia zapasowa zostala wczytana !"));
				}
				break;
	}
	
	wwp_czynnosc = 0;
	gtk_widget_destroy (GTK_WIDGET (wwp_widget));
}


void on_wwp_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wwp = lookup_widget (GTK_WIDGET (button), "window_wybierz_plik");
	gtk_widget_destroy (GTK_WIDGET (wwp));
}


void on_zrob_kopie_zapasowa1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *wkz = create_window_kopia_zapasowa ();
	gtk_widget_show (GTK_WIDGET (wkz));
}


void on_wczytaj_kopie_zapasowa1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wwp_widget = create_window_wybierz_plik ();
	
	wwp_czynnosc = 1;
	gtk_widget_show (GTK_WIDGET (wwp_widget));
}


void on_wkz_anuluj_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wkz = lookup_widget (GTK_WIDGET (button), "window_kopia_zapasowa");
	gtk_widget_destroy (GTK_WIDGET (wkz));
}


// Tworzenie kopii zapasowej
void on_wkz_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	GtkWidget *wkz = lookup_widget (GTK_WIDGET (button), "window_kopia_zapasowa");
	
	GtkWidget *wkz_kompresja = lookup_widget (GTK_WIDGET (wkz), "wkz_kompresja");
	gboolean  kompresja      = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wkz_kompresja));
	
	czas_struct tmp_czas = czas ();
	typ_data    tmp_data = data ();
	
	char polecenie[150];
	
	if (kompresja == TRUE) {
		sprintf (polecenie, "tar -zcvf gtu-kopia-%d-%d-%d-%d%d%d.tar.gz .gnutu", tmp_data.dzien, tmp_data.miesiac, tmp_data.rok, tmp_czas.godzina, tmp_czas.minuta, tmp_czas.sekunda);
	} else {
		sprintf (polecenie, "tar -cvf gtu-kopia-%d-%d-%d-%d%d%d.tar .gnutu", tmp_data.dzien, tmp_data.miesiac, tmp_data.rok, tmp_czas.godzina, tmp_czas.minuta, tmp_czas.sekunda);
	}
	
	printf (_("Tworzenie kopii zapasowej...\n"));
	system (polecenie);
	printf (_("Tworzenie kopii zapasowej zakonczone !\n"));
	
	gtk_widget_destroy (GTK_WIDGET (wkz));
	
	komunikat (_("Kopia zapasowa zostala utworzona i zapisana\n w katalogu domowym uzytkownika !"));
}


void on_mw_cofnij_btn_clicked (GtkButton *button, gpointer user_data)
{
	cofnij_modyfikacje ();
}


void on_cofnij1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	cofnij_modyfikacje ();
}


gboolean on_window_dziennik_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	wn_zapisz_notatke ();
	return FALSE;
}


void on_dziennik1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wd_widget = create_window_dziennik ();
	
	wn_edytowany_dzien = biezaca_data;
	
	wn_wczytaj_notatke  ();
	wn_uaktualnij_liste ();
	
	gtk_widget_show (GTK_WIDGET (wd_widget));
}


void on_zestawienie_ocen1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	wzo_widget = create_window_zestawienie_ocen ();
	gtk_widget_show (GTK_WIDGET (wzo_widget));
}


// Kliknieto przycisk w oknie zestawienie ocen - wyswietlamy wykres
void on_wzo_pokaz_btn_clicked (GtkButton *button, gpointer user_data)
{
	wzo_uzupelnij_liste_ocen ();
}


// Kliknieto przycisk OK w oknie zestawienie ocen
void on_wzo_ok_btn_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_destroy (GTK_WIDGET (wzo_widget));
}


// Wybrano inna date w oknie dziennika - wczytujemy inny wpis
void on_wn_data_date_changed (GnomeDateEdit *gnomedateedit, gpointer user_data)
{
	wn_zapisz_notatke   ();
	wn_uaktualnij_liste ();
	
	GtkWidget *wn_data = lookup_widget (GTK_WIDGET (gnomedateedit), "wn_data");
	wn_edytowany_dzien = data_rozkoduj (gnome_date_edit_get_time (GNOME_DATE_EDIT(wn_data)));
	wn_edytowany_dzien.miesiac--;
	
	wn_wczytaj_notatke ();
}


// Wybrano notatke w oknie dziennika (z listy) - wczytujemy wybrany wpis
void on_wn_lista_select_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data)
{
	wn_zapisz_notatke   ();
	
	char *data;
	char  data2[10];
	
	gtk_clist_get_text (GTK_CLIST (clist), row, column, &data);
	
	wn_edytowany_dzien.dzien   = atoi (strtok (data, "-"));
	wn_edytowany_dzien.miesiac = atoi (strtok (NULL, "-"));
	wn_edytowany_dzien.rok     = atoi (strtok (NULL, ""));
	
	wn_edytowany_dzien.miesiac--;
	
	sprintf (data2, "%d-%d-%d", wn_edytowany_dzien.dzien, (wn_edytowany_dzien.miesiac + 1), wn_edytowany_dzien.rok);
	gtk_clist_set_text (GTK_CLIST (clist), row, column, data2);
	
	wn_wczytaj_notatke ();
}
