/***************************************************************************
 *            wzo.c
 *  
 *  Sat Feb 21 22:27:09 2004
 *  Copyright (C) 2004  Marcin Krzywonos
 *  e-mail: linman@op.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#include "wzo.h"
#include "engine.h"


void wzo_uzupelnij_liste_ocen ()
{
	GtkWidget *wzo_lista_ocen    = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_lista_ocen");
	GtkWidget *wzo_data_poczatek = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_data_poczatek");
	GtkWidget *wzo_data_koniec   = lookup_widget (GTK_WIDGET (wzo_widget), "wzo_data_koniec");
	
	gtk_clist_freeze (GTK_CLIST (wzo_lista_ocen));
	gtk_clist_clear (GTK_CLIST (wzo_lista_ocen));
	
	lista_ocen lista [30];
	
	typ_data poczatek = data_rozkoduj (gnome_date_edit_get_time (GNOME_DATE_EDIT(wzo_data_poczatek)));
	typ_data koniec   = data_rozkoduj (gnome_date_edit_get_time (GNOME_DATE_EDIT(wzo_data_koniec)));
	poczatek.miesiac--;
	koniec.miesiac--;
	
	zestawienie_ocen (lista, poczatek, koniec);
	
	gchar *ins_str[3];
	int    i       = 0;
	float  srednia = 0;
	int    ilosc   = 0;
	float  s_tmp   = 0;
	char   tmp    [5];
	
	while (i != 30) {
		if (strlen (lista[i].przedmiot) < 1)
			break;
		
		s_tmp = oblicz_srednia (lista[i].oceny);
		sprintf (tmp, "%.2f", s_tmp);
		
		srednia += s_tmp;
		ilosc++;
		
		ins_str[0] = lista[i].przedmiot;
		ins_str[2] = tmp;
		
		char tmp_txt[512];
		wzo_wstaw_przecinki (tmp_txt, lista[i].oceny);
		ins_str[1] = tmp_txt;
		
		gtk_clist_insert (GTK_CLIST (wzo_lista_ocen), 0, ins_str);
		
		i++;
	}
	
	if ((srednia == 0) | (ilosc == 0))
		sprintf (tmp, _("BRAK"), (srednia / ilosc));
	else
		sprintf (tmp, "%.2f", (srednia / ilosc));
		
	ins_str[0] = "---------------";
	ins_str[1] = _("srednia");
	ins_str[2] = tmp;
	
	gtk_clist_insert (GTK_CLIST (wzo_lista_ocen), i, ins_str);
	
	gtk_clist_thaw (GTK_CLIST (wzo_lista_ocen));
}


void wzo_wstaw_przecinki (char tekst[512], char oceny[512])
{
	int i = 0;
	strcpy (tekst, "");
	
	while (i <= strlen (oceny)) {
		sprintf (tekst, "%s%c, ", tekst, oceny[i]);
		
		i++;
	}
}
